module.exports = {

    /**
     * Positionne par rapport au cote gauche de l'ecran
     * @param posX
     * @returns {*}
     */
    responsiveBorderLeft : (posX)=>{
        return((-(windowWidth - DEFAULT_WIDTH*scale)/2 /scale)+posX);
    },

    /**
     * Positionne par rapport au cote droit de l'ecran
     * @param posX
     * @returns {*}
     */
    responsiveBorderRight : (posX)=>{
        return((+(windowWidth - DEFAULT_WIDTH*scale)/2 /scale)+posX);
    },

    /**
     * Positionne par rapport au haut de l'ecran
     * @param posY
     * @returns {*}
     */
    responsiveBorderTop : (posY)=>{
        return((-(windowHeight - DEFAULT_HEIGHT*scale)/2 /scale)+posY);
    },

    /**
     * Positionne par rapport au bas de l'ecran
     * @param posY
     * @returns {*}
     */
    responsiveBorderBottom : (posY)=>{
        return((+(windowHeight - DEFAULT_HEIGHT*scale)/2 /scale)+posY);
    },

    /**
     * Permet de placer un element dans une carte
     * @param cardWidth
     * @param cardHeight
     * @param elementWidth
     * @param elementHeight
     * @param nbDivElem
     * @returns {number}
     */
    calculateScaleElementInCard : (cardWidth,cardHeight,elementWidth,elementHeight,nbDivElem)=>{
        var widthElementInCard = cardWidth/(nbDivElem);
        var heightElementInCard = cardHeight/(nbDivElem);
        var scaleWidth = widthElementInCard/elementWidth;
        var scaleHeight = heightElementInCard/elementHeight;
        return Math.max(scaleWidth,scaleHeight)-(Math.min(scaleWidth,scaleHeight)/3);
    },

    /**
     * calcule l'echelle et renvoie la taille voulue dans le jeu pour un element
     * @param elementWidth
     * @param elementHeight
     * @returns {number}
     */
    /*calculateScale : (elementWidth,elementHeight,scaleElement)=>{
        var scaleW = elementWidth/(windowWidth/scale);
        var scaleH = elementHeight/(windowHeight/scale);
        return Math.max(scaleElement/scaleW,scaleElement/scaleH);   //cards scale bddjeu : 0.2
    },*/

    calculateScaleCards : (elementWidth,elementHeight,scaleElement)=> {
        var scaleCard;
        var scaleW = elementWidth / (windowWidth / scale);
        var scaleH = elementHeight / (windowHeight / scale);
        if (windowWidth / windowHeight > 2){
            scaleCard = Math.max(scaleElement / scaleW, scaleElement / scaleH) - Math.min(scaleElement / scaleW, scaleElement / scaleH) / 2;   //cards scale bddjeu : 0.2
            }
        else{
            scaleCard = Math.max(scaleElement / scaleW, scaleElement / scaleH);
        }
        return scaleCard;
    }
};