module.exports = {
    perso : null,
    speak : null,
    text : null,
    persoAnimKey : null,
    atlasSpeakKey : null,
    elementSpeakKey : null,
    listElementContainer : [],
    container : null,

    /**
     * initialise l'élement texte dans la bulle et le place
     * @param {object} contextScene
     * @param {number} posX
     * @param {number} posY
     * @param {string} text
     * @param {string} fontFamilyText
     * @param {string} fontSizeText
     * @param {string} colorText
     * @param {string} originText
     */
    setText : (contextScene,pos,text,fontFamilyText,fontSizeText,colorText,originText)=>{
        mPersoSpeak.text = contextScene.add.text(pos[0], pos[1], text, {fontFamily:fontFamilyText, fontSize:fontSizeText, color:colorText});
        mPersoSpeak.text.setOrigin(originText);
        mPersoSpeak.listElementContainer.push(mPersoSpeak.text);
    },

    /**
     * initialise la coccinelle
     * @param {object} contextScene
     * @param {number} posX
     * @param {number} posY
     * @param {string} imageKey
     * @param {string} frameKey
     */
    setPerso : (contextScene,imageKey,frameKey,scalePerso,scaleContainer)=>{
        mPersoSpeak.perso = contextScene.add.sprite(0,0,imageKey,frameKey);
        mPersoSpeak.perso.setScale(scalePerso/scaleContainer);
        mPersoSpeak.listElementContainer.push(mPersoSpeak.perso);
    },

    /**
     * initialise la bulle
     * @param {object} contextScene
     * @param {number} posX
     * @param {number} posY
     * @param {string} imageKey
     * @param {string} frameKey
     */
    setSpeak : (contextScene,pos,imageKey,frameKey)=>{
        mPersoSpeak.speak = contextScene.add.image(pos[0],pos[1],imageKey,frameKey);
        //mPersoSpeak.speak.setScale(1.5); // a enlever juste pour la demo
        mPersoSpeak.listElementContainer.push(mPersoSpeak.speak);
    },

    /**
     * initialise le container le place et le met à l'échelle
     * @param {object} contextScene
     * @param {number} posX
     * @param {number} posY
     * @param {number} scaleContainer
     */
    setContainer : (contextScene,pos,scaleContainer,nbElem)=>{
        mPersoSpeak.container = contextScene.add.container(pos[0],pos[1],mPersoSpeak.listElementContainer);
        var x = mDisplayInScreen.responsiveBorderLeft(mPersoSpeak.container.x);
        mPersoSpeak.container.setX(x);
        mPersoSpeak.container.setScale(scaleContainer);
        var arrayPersoSize = mDisplayElement.setSizeOfArrayObject(mPersoSpeak.listElementContainer.slice(0,nbElem));
        mPersoSpeak.container.setSize(arrayPersoSize[0],arrayPersoSize[1]);
        mPersoSpeak.container.setInteractive();
    }
}