module.exports = {
    alphaResult : null,
    resultKey : null,
    gapResult : null,
    container : null,
    resultGroup : null,
    orientation : null,
    resultWidth : null,
    resultHeight : null,
    resultStartX : null,
    resultStartY : null,
    resultScale : null,

    /**
     * Definit l'ensemble du contenu de la partie "Score"
     * @param {number} posX
     * @param {number} posY
     * @param {number} alphaResult
     * @param {string} resultKey
     * @param {number} gapResult
     * @param {number} resultScale
     * @param {string} orientation
     * @param {object} contextScene
     * @param {number} nbForWin
     */
    setResults : (pos,alphaResult,resultKey,gapResult,resultScale,orientation,contextScene,nbForWin) =>{
        mResults.alphaResult = alphaResult;
        mResults.resultKey = resultKey;
        mResults.resultGroup = contextScene.add.group();
        mResults.resultWidth = contextScene.textures.get(resultKey).frames["__BASE"].width*resultScale;
        mResults.resultHeight = contextScene.textures.get(resultKey).frames["__BASE"].height*resultScale;
        mResults.resultScale = resultScale;
        mResults.orientation = orientation;
        mResults.gapResult = gapResult;
        mResults.setStartResult(nbForWin);
        mResults.generateResult(nbForWin,contextScene);
        mResults.container = contextScene.add.container(pos[0],pos[1],mResults.resultGroup.children.entries);
        if (orientation == "vertical"){
            var x = mDisplayInScreen.responsiveBorderRight(mResults.container.x);
            mResults.container.setX(x);
        }
        else {
            var y = mDisplayInScreen.responsiveBorderBottom(mResults.container.y);
            mResults.container.setY(y);
        }
        },

    /**
     * centre verticalement ou horizontalement la partie score en fonction du nombre d'elements de la partie "Score"
     * @param {number} nbForWin
     */
    setStartResult : (nbForWin) => {
        if (mResults.orientation == "vertical"){
            mResults.resultStartX = 0;
            mResults.resultStartY = -(((nbForWin/2)-0.5)*(mResults.gapResult+mResults.resultHeight));
        }
        else{
            mResults.resultStartX = -(((nbForWin/2)-0.5)*(mResults.gapResult+mResults.resultWidth));
            mResults.resultStartY = 0;
        }
    },

    /**
     * genere l'ensemble de la partie "Score"
     * @param {number} nbForWin
     * @param {object} contextScene
     */
    generateResult : function(nbForWin,contextScene){
        var posX = mResults.resultStartX;
        var posY = mResults.resultStartY;
        for(var i=0;i<nbForWin;i++){
            this.configureresult(posX,posY,i,contextScene);
            if (mResults.orientation == "vertical") {
                posY = posY + (mResults.gapResult + mResults.resultHeight);
            }
            else{
                posX = posX + (mResults.gapResult+mResults.resultWidth);
            }
        }
    },

    /**
     * configure et ajoute au groupe un element du score
     * @param {number} posX
     * @param {number} posY
     * @param {number} ind
     * @param {object} contextScene
     */
    configureresult : function(posX,posY,ind,contextScene) {
        var elem = contextScene.add.image(posX,posY,mResults.resultKey);
        elem.setScale(mResults.resultScale,mResults.resultScale);
        elem.setAlpha(mResults.alphaResult);
        elem.setTint("0x000000");
        mResults.resultGroup.add(elem);
    },

}