global.DEFAULT_WIDTH = 800;
global.DEFAULT_HEIGHT = 600;
global.NB_OBJECTS = null;
global.windowWidth = window.innerWidth;
global.windowHeight = window.innerHeight;
global.scale = Math.min(windowWidth/DEFAULT_WIDTH,windowHeight/DEFAULT_HEIGHT);
global.gamelevel = null;
global.nbElementInCase = [1,1,1,1,1,1];
global.posDomino = [[-1,-1],[1,-1],[1,0],[0,1]];
global.response = null;
global.previousScene = null;
global.actualScene = null;

global.mVideo = require('../js/mVideo.js');
global.trasmetta = require('../js/trasmetta.js');
global.inpiu = require('../js/inpiu.js');
global.mReturn = require('../js/mReturn.js');
global.mButtons = require('../js/mButtons.js');
//global.mLoto = require('../js/mLoto.js');
global.mRandom = require('../js/mRandom.js');
global.mDisplayElement = require('../js/mDisplayElement.js');
global.mAnimation = require('../js/mAnimation.js');
global.mLevel = require('../js/mLevel.js');
global.mDatabaseOperations = require('../js/mDatabaseOperations.js');
global.mObjectOperation = require('../js/mObjectOperation.js');
global.mDecor = require('../js/mDecor.js');
global.mCards = require('../js/mCards.js');
global.mSongManage = require('../js/mSongManage.js');
global.mResults = require('../js/mResults.js');
global.mPersoSpeak = require('../js/mPersoSpeak.js');
global.mDisplayInScreen = require('../js/mDisplayInScreen.js');

import Phaser from "phaser";

window.addEventListener('load', function() {
	var game = new Phaser.Game({
        "title": "GameCo",
        "width": window.innerWidth,
        "height": window.innerHeight,
        "type": Phaser.AUTO,
        "overflow": 'hidden',
        "physics":
        	{	"default": 'arcade',
        	"arcade":
        		{
            		"debug": false
        			}
				},
		"audio":{ "disableWebAudio": true }
	});
	/*game.scene.load.audio('music','assets/son/musiqueambiance.mp3');*/
	//game.scene.load.audio('clickSong','assets/son/menuson.mp3');
	setTimeout(()=>{game.scene.add("Boot", Boot, true);}, 5000);
});

class Boot extends Phaser.Scene {

	preload() {
		//this.load.pack("packCo",'assets/pack.json','scriptScene');
		this.load.pack("packCo",'assets/pack.json');
		this.load.audio('music','assets/son/musiqueambiance.mp3');
		//this.load.audio('clickSong','assets/son/menuson.mp3');
		//this.load.audio('bad','assets/son/erreur.mp3');
		//this.load.audio('clickSong','assets/son/click1.mp3');
		for(var i=0;i<6;i++){
			this.load.audio('themeElements'+i.toString(),bddThemeJeu[i].urlElements);
			this.load.audio('themeColors'+i.toString(),bddThemeJeu[i].urlColors);
			this.load.audio('themeNumbers'+i.toString(),bddThemeJeu[i].urlNumbers);
			this.load.audio('songTheme'+i.toString(),bddSong[i].url);
		}
		/*this.load.audio('clickSong','assets/son/menuson.mp3');
		this.load.audio('bad','assets/son/erreur.mp3');*/
		
		

		/*this.load.audio('voixC', [
        'assets/son/voix_enfant.mp3'*/
    //]);
		//this.load.pack("menuCo", 'assets/pack.json');
	}

	_create() {
		this.add.image(0.0, 0.0, bddJeu['Home'].backgroundHome);
	}

	create() {
		this._create();

		/*if (mSongManage.music==null){
		}*/
		/*this.game.config.audio.disableWebAudio = "false";*/
		/*new WebAudioSoundManager(this,game);*/
		/*this.sound.pauseOnBlur = false;*/
		
		
		/*var buttonPlay = this.add.image(0.0, 0.0,'n_play');*/
		
		this.cameras.main.centerOn(0,0);
        this.cameras.main.setZoom(scale);
		/*buttonPlay.setInteractive();
		buttonPlay.on('pointerdown', () => {this.playGame()});*/
		/*mSongManage.music = this.sound.add('music',{loop : true});*/
		/*console.log(this.sound.isLocked());*/
		//if (mSongManage.music==null){
			/*this.sound.game.boot();*/
			//mSongManage.music = this.sound.add('music',{loop : true});
			/*this.sound.game.sound.game.boot();*/
			/*this.sound.setDecodedCallback([mSongManage.music], ()=>{mSongManage.music.play();console.log('call');}, this);*/


			/*mSongManage.soundloader.on('complete', () => {console.log("comp");mSongManage.music.play();})
			mSongManage.soundloader.start();*/
			/*mSongManage.music = this.sound.add('music',{loop : true});
			mSongManage.music.play();*/
		//}
		console.log(this.sound.game);
		console.log(mSongManage.soundloader);
		/*mSongManage.initMusicGame(this);*/
		//this.load.audio('clickSong','assets/son/menuson.mp3');
		this.load.audio('music','assets/son/musiqueambiance.mp3');
		//this.load.audio('clickSong','assets/son/menuson.mp3');
		//this.load.audio('clickSong','assets/son/click.mp3');
		//mSongManage.clickSong = this.sound.add(mSongManage.clickSongKey);
		mSongManage.music = this.sound.add('music',{loop : true});
		//mSongManage.clickSong = this.sound.add('clickSong');
		//mSongManage.clickSong = this.sound.add('clickSong');
		console.log(Object.keys(bddThemeJeu).length);
		this.scene.add("Menu", Menu, false);
		/*this.scene.setVisible(false, "Menu"); */
		this.scene.add("Level", Level, false);
		this.scene.add("Color", Color, false);
		this.scene.add("Card", Card, false);
		this.scene.add("Numari", Numari, false);
        this.scene.add("Song", Song, false);
        mDatabaseOperations.loadStateOfTheme(bddThemeJeu);
        document.addEventListener("backbutton",
            					()=>{mReturn.onReturn(this.scene,this.game);}, false);

        document.addEventListener("pause",()=>{this.game.sound.pauseAll();}, false);
        document.addEventListener("resume",()=>{this.game.sound.resumeAll();}, false);

        this.game.events.on("hidden",()=>{this.game.sound.pauseAll();if(mVideo.player!=null){mVideo.video.pause();}});
		this.game.events.on("visible",()=>{this.game.sound.resumeAll();});
		var buttonPlay = document.getElementById('button_start');
		/////this.load.once('complete',()=>{
		//setTimeout(()=>{ 
			document.getElementById('divstart').style.display = 'block';
		buttonPlay.onclick = () => {this.playGame()}; 
	//}, 5000);
			
		////});
		////this.load.start();
	}

	playGame(){
		/*mSongManage.initMusicGame(this);*/
		/*this.scene.stop("Menu");
		this.scene.stop("Boot");*/
		/*this.scene.setVisible(true,"Menu");*/
		/*this.load.audio('music',"assets/son/musiqueambiance.mp3");*/
        this.load.once('complete',()=>{
			this.load.audio('clickSong','assets/son/menuson.mp3');
			//mSongManage.clickSong = this.sound.add('clickSong');
			document.getElementById('divstart').style.display = 'none';
			/*mSongManage.music = this.sound.add('music',{loop : true});
        	mSongManage.music.volume = 0.8;
			mSongManage.music.play();*/
			this.scene.stop("Boot");
			this.scene.start("Menu");
    	});
        this.load.start();
		
		/*mSongManage.setMusicVolume(0.8);*/
		/*this.game.sound.resumeAll();*/
		/*console.log(this.sound.isLocked);*/
	}
}
